> For the complete documentation index, see [llms.txt](https://docs.petabox.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.petabox.io/http-api-compatible-with-amazon-s3/api-reference/putbucketpolicy.md).

# PutBucketPolicy

Applies a Petabox bucket policy to a Petabox bucket

If you are using an identity other than the root user of the Petabox account that owns the bucket, the calling identity must have the `PutBucketPolicy` permissions on the specified bucket and belong to the bucket owner's account in order to use this operation.

If you don't have `PutBucketPolicy` permissions, Petabox returns a `403 Access Denied` error. If you have the correct permissions, but you're not using an identity that belongs to the bucket owner's account, Petabox returns a `405 Method Not Allowed` error.

{% hint style="danger" %}
**Important**

To ensure that bucket owners don't inadvertently lock themselves out of their own buckets, the root principal in a bucket owner's Petabox account can perform the `GetBucketPolicy`, `PutBucketPolicy`, and `DeleteBucketPolicy` API actions, even if their bucket policy explicitly denies the root principal's access. Bucket owner root principals can only be blocked from performing these API actions by VPC endpoint policies and Petabox Organizations policies.
{% endhint %}

## Request Syntax <a href="#api_putbucketpolicy_requestsyntax" id="api_putbucketpolicy_requestsyntax"></a>

```http
PUT /?policy HTTP/1.1
Host: Bucket.s3.petabox.io
Content-MD5: ContentMD5
x-amz-sdk-checksum-algorithm: ChecksumAlgorithm
x-amz-confirm-remove-self-bucket-access: ConfirmRemoveSelfBucketAccess
x-amz-expected-bucket-owner: ExpectedBucketOwner

{ Policy in JSON format }
```

## URI Request Parameters <a href="#api_putbucketpolicy_requestparameters" id="api_putbucketpolicy_requestparameters"></a>

The request uses the following URI parameters.

#### Bucket

The name of the bucket.

Required: Yes

#### Content-MD5

The MD5 hash of the request body.

For requests made using the Command Line Interface (CLI) or SDKs, this field is calculated automatically.

#### x-amz-confirm-remove-self-bucket-access

Set this parameter to true to confirm that you want to remove your permissions to change this bucket policy in the future.

#### x-amz-expected-bucket-owner

The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code `403 Forbidden` (access denied).

#### x-amz-sdk-checksum-algorithm

Not supported at the moment.

## Request Body <a href="#api_putbucketpolicy_requestbody" id="api_putbucketpolicy_requestbody"></a>

The request accepts the following data in JSON format.

## Response Syntax <a href="#api_putbucketpolicy_responsesyntax" id="api_putbucketpolicy_responsesyntax"></a>

```
HTTP/1.1 200
```

## Response Elements <a href="#api_putbucketpolicy_responseelements" id="api_putbucketpolicy_responseelements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Examples <a href="#api_putbucketpolicy_examples" id="api_putbucketpolicy_examples"></a>

### Sample Request <a href="#api_putbucketpolicy_example_1" id="api_putbucketpolicy_example_1"></a>

The following request shows the PUT individual policy request for the bucket.

```http
PUT /?policy HTTP/1.1
Host: bucket.s3.<Region>.petabox.io  
Date: Tue, 04 Apr 2010 20:34:56 GMT  
Authorization: authorization string

{
    "Version":"2008-10-17",
    "Id":"aaaa-bbbb-cccc-dddd",
    "Statement" : [
        {
            "Effect":"Allow",
            "Sid":"1", 
            "Principal" : {
                "AWS":["111122223333","444455556666"]
            },
            "Action":["s3:*"],
            "Resource":"arn:aws:s3:::bucket/*"
        }
     ] 
}
```

### Sample Response <a href="#api_putbucketpolicy_example_2" id="api_putbucketpolicy_example_2"></a>

This example illustrates one usage of PutBucketPolicy.

```http
HTTP/1.1 204 No Content  
x-amz-id-2: Uuag1LuByR5Onimru9SAMPLEAtRPfTaOFg==  
x-amz-request-id: 656c76696e6727732SAMPLE7374  
Date: Tue, 04 Apr 2010 20:34:56 GMT  
Connection: keep-alive  
Server: Petabox 
```
